# Generated by Django 2.0.4 on 2018-04-12 14:39

from django.db import migrations

DAYS_NAMES = ['J1', 'J2', 'J3']
PROVIDERS = [
        {
            'name': 'Google Maps',
            'type': 'M',
            'url_scheme': 'comgooglemaps://?daddr={latitude},{longitude}&directionsmode=driving'
        },
        {
            'name': 'Google Maps',
            'type': 'D',
            'url_scheme': 'https://maps.google.com?daddr={latitude},{longitude}&directionsmode=driving'
        },
        {
            'name': 'Waze',
            'type': 'M',
            'url_scheme': 'waze://?ll={latitude},{longitude}&navigate=yes'
        },
    ]


def create_days(apps, schema_editor):
    Day = apps.get_model('gps', 'Day')
    days = []
    for name in DAYS_NAMES:
        day = Day.objects.filter(name__iexact=name).last()
        if day is None:
            days.append(Day(name=name))

    if days:
        Day.objects.bulk_create(days)


def rollback_create_days(apps, schema_editor):
    Day = apps.get_model('gps', 'Day')
    for name in DAYS_NAMES:
        day = Day.objects.filter(name__iexact=name).last()
        if day:
            day.delete()


def create_navigation_providers(apps, schema_editor):
    NavigationProvider = apps.get_model('gps', 'NavigationProvider')
    providers_to_create = []

    for provider in PROVIDERS:
        np = NavigationProvider.objects.filter(name__iexact=provider['name'], type=provider['type']).last()
        if np is None:
            providers_to_create.append(
                NavigationProvider(
                    name=provider['name'],
                    url_scheme=provider['url_scheme'],
                    type=provider['type']
                )
            )

    if providers_to_create:
        NavigationProvider.objects.bulk_create(providers_to_create)


def rollback_create_navigation_providers(apps, schema_editor):
    NavigationProvider = apps.get_model('gps', 'NavigationProvider')
    for provider in PROVIDERS:
        np = NavigationProvider.objects.filter(
            name__iexact=provider['name'],
            type=provider['type'],
            url_scheme=provider['url_scheme']
        ).last()
        if np:
            np.delete()


class Migration(migrations.Migration):
    dependencies = [
        ('gps', '0011_auto_20180412_1628'),
    ]

    operations = [
        migrations.RunPython(create_days, rollback_create_days),
        migrations.RunPython(create_navigation_providers, rollback_create_navigation_providers),
    ]
